IObject = function(){};
IObject.subClass = function(){
	var tmpClass = function(){this.init()};
	for (var i in this)
		tmpClass[i] = this[i];
	tmpClass.prototype = new this();
	tmpClass.superClass = this;
	return tmpClass;
};

IObject.handle = function(error){
	throw(error);
};

IObject.create = function(){

	var obj = this.prototype;
	
	obj.clone = function(){
		if (this._clone.prototype!==this) {
			this._clone = function(){this.init()};
			this._clone.prototype = this;
		}
		return new this._clone();
	};
	
	obj._clone = function(){};
		
	obj.init = function(){
		// overload
	};
		
	obj.handle = function(error){
		throw(error);
	};
		
	obj.timeout = function(handler, delay){
		var self = this;
		var wrapper = function(){handler.call(self)};
		return window.setTimeout(wrapper, delay ? delay : 0);
	};
	
	obj.toString = function(){
		var str = "";
		for( var tmp in this){
			//if(typeof this[tmp] == "string")
				str += tmp + ":" + this[tmp] + "\n";
		};
		return str;
	};
	
}

IObject.create();