IRSS = IModel.subClass();

IRSS.create = function(){
	
	var obj = this.prototype;
	
	obj.init = function(){
		this._xpath = "//rss/channel/";
		this._names = ["title", "link"];
		this._box = "rss";
		this._items = [];
		this._channel = null;
	}
	
	obj.setAction = function (url) {
		this._action = url;
	};
	
	obj.getAction = function () {
		return this._action;
	};
	
	obj.getBoxObj = function (){
		return document.getElementById(this._box);
	}
	
	obj.setBox = function (box){
		this._box = box;
	}
	
	obj.getBox = function (){
		return this._box;
	}
	
	obj.draw = function (){
		if(!(this._names + "")){
			for(var j = 0; j < this._XML.documentElement.childNodes.length; j ++){
				var name = this._XML.documentElement.childNodes[j].nodeName;
				if(name == "#text")
					continue;
				this._names.push(name);
			}
		}
		if(this._names.length){
			for(var i = 0; i < this._names.length; i ++){
				var property = obj.getNodeText(this._XML.selectNodes(this._xpath + this._names[i])[0]);
				if(property){
					if(!IString.isEmpty(this._box) && this.getElement(this._box + ":" + this._names[i])){
						this.getElement(this._box + ":" + this._names[i]).setText(property);
					}else if(this.getElement(this._names[i]))
						this.getElement(this._names[i]).setText(property);
				}
			}
		}
			var temp = this._XML.selectNodes(this._xpath + "item");
			for(var i = 0; i < temp.length; i ++){
				var item = new IModel();	
				item._XML = temp[i];
				this._items.push(item);
			}
			for(var i = 0; i < this._items.length; i++){
				var itemDiv = document.createElement("table");
				itemDiv.width = "100%";
				itemDiv.cellPadding = "0";
				var itemRow = itemDiv.insertRow(-1);
				var itemCell = itemRow.insertCell(-1);
				itemCell.id = this._box + ":content:" + i;
				var a = document.createElement("a");
				a.href = obj.getNodeText(this._items[i]._XML.selectSingleNode("link"));
				a.appendChild( document.createTextNode( obj.getNodeText(this._items[i]._XML.selectSingleNode("title"))));
				itemCell.appendChild(a);
				if(!IString.isEmpty(this._box)){
					var first = document.getElementById(this._box + ":content").firstChild;
					if(first)
						document.getElementById(this._box + ":content").insertBefore(itemDiv, first);
					else
						document.getElementById(this._box + ":content").appendChild(itemDiv);
				}else{
					document.body.appendChild(itemDiv);
				}
			}
		return this._names;
	}
	
	obj.response = function (response) {
		var self = this;
		
		if(response){
			this._response = response;
		}
		if(this._isSend){
			this._http.onreadystatechange = function (){
				if(self._http.readyState == 4)
					if(self._http.status < 400){
						callbackHandler();
					}else{
						self._http.abort();
						ILog.error("abort because of wrang status");
					}
			}
		}else{
			return null;
		}
		
		function callbackHandler() {
			self._XML = self._http.responseXML;
			self.draw();
		}
	};
	
}

IRSS.create();